    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Mass Arroyo,Javier I. Cano Alberola,Jaume Gasa Gmez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#ifndef __ACTOR_H__
#define __ACTOR_H__

#include "globals.h"

Actor* CreateActor(UI8 id, UI8 xTile, UI8 yTile, UI8 xVel, UI8 yVel, UI8 width, UI8 height,
	Direction direction, const I8* sprite, bool visible, ActorType type);

Actor* CreateAnimatedActor(UI8 id, UI8 xTile, UI8 yTile, UI8 xVel, UI8 yVel, UI8 width,
	UI8 height, Direction direction, const I8* sprite, bool visible,
	ActorType type, UI8 frameTime, UI8 maxFrames, bool playAnimation);

void DeleteActor(Actor* actor);

void CreateMovement(Movement* movement);
void CreateMovementCoords(Movement* movement, UI8 xStart, UI8 xEnd, Direction direction, UI8 amount);

void SetActorScreenPosition(UI8 x, UI8 y, Actor* actor);
void SetActorTilePosition(UI8 x, UI8 y, Actor* actor);
void SetActorDirection(Direction direction, Actor* actor);

void DrawActor(Actor* actor);
void UpdateActor(Actor* actor);

void PrintActor(UI8 x, UI8 y, Actor* actor, bool clearScreen);

#endif