﻿    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Massó Arroyo,Javier I. Cano Alberola,Jaume Gasa Gómez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "ai.h"
#include "input.h"

PathMap pathMap;

void AddOpen(unsigned char x, unsigned char y)
{
	
	if(pathMap[x][y].open != 1)
	{
		pathMap[x][y].open = 1;
	}
	if(pathMap[x][y].close != 0)
	{
		pathMap[x][y].close = 0;
	}
}


void AddClose(unsigned char x, unsigned char y)
{
	if(pathMap[x][y].close != 1)
	{
		pathMap[x][y].close = 1;
	}
	if(pathMap[x][y].open != 0)
	{
		pathMap[x][y].open = 0;
	}
}

void InitNodes()
{
	unsigned char i,j;
	
	for(i=0; i<MAP_HEIGHT; ++i)
	{
		for(j=0; j<MAP_WIDTH; ++j)
		{
			pathMap[i][j].open = 0;
			pathMap[i][j].close = 0;
			pathMap[i][j].g = 0;
			pathMap[i][j].h = 0;
			pathMap[i][j].f = 0;
			
			pathMap[i][j].parentx = 0;
			pathMap[i][j].parenty = 0;
		}
	}
}
	
PathStack* Astar(unsigned char startx, unsigned char starty, unsigned char endx, unsigned char endy, Actor *actor)
{	
	unsigned char init=0;
	PathStack *stack = &gActorPaths[0];
	
	unsigned char i=0;
	unsigned char j=0;
	
	unsigned int auxx=0;
	unsigned int auxy=0;
	
	unsigned char x=0;
	unsigned char y=0;
	
	int f = 1000;
	
	char hx[4]={1,0,-1,0};
	char hy[4]={0,1,0,-1};
	
	unsigned char currentx=startx;
	unsigned char currenty=starty;
	
	unsigned char found=1;
	
	CreatePathStack(stack, actor, 40);
	
	InitNodes();
	
	pathMap[startx][starty].open = 1;
	
	
	while((currentx!=endx || currenty!=endy) && found!=0)
	{
		found = 0;
	
		if(init!=0) {
		//Buscar el nodo con menor f
			f=1000;
			x = 0;
			y = 0;
			
			for(i=0; i<MAP_HEIGHT; i++)
			{
				for(j=0; j<MAP_WIDTH; j++) 
				{
					if(pathMap[i][j].open==1)
					{
						if(pathMap[i][j].f < f) 
						{
							found = 1;
							x = i;
							y = j;
							f = pathMap[i][j].f;
						}
					}
				}
			}
			
			currentx = x;
			currenty = y;
		}
		///////////////////////////////////////////////////////////////////////////////////////////
		
	//printf("Current = (%u,%u) ",currentx,currenty);
		
		
		if(found == 1 || ( currentx == 0 && currenty == 0))
		{
				
		AddClose(currentx, currenty);
		
		//Si llegamos al final, recorremos el camino añadiendolo al stack
		if(currentx==endx && currenty==endy)
		{			
			while(currentx != startx || currenty != starty)
			{
				//AUXILIARES
				auxx=currentx;
				auxy=currenty;
				
				//Añadir al path el camino
				PushPathNode(stack, currentx, currenty);
				
				//printf("CAMINO = (%u,%u) ",currentx,currenty);
				
				//Apuntar al padre
				currentx=pathMap[auxx][auxy].parentx;
				currenty=pathMap[auxx][auxy].parenty;
				
			}
			
			//printf("START = (%u,%u) ",startx,starty);
			PushPathNode(stack, startx, starty);
			
			return stack;
		}
		
		
		for(i=0; i<4;i++)
		{
			bool ok = false;
			if(i==0 && currentx<MAP_WIDTH)
			{
				ok=true;
			}
			if(i==1 && currenty<MAP_HEIGHT)
			{
				ok=true;
			}
			if(i==2 && currentx>0)
			{
				ok=true;
			}
			if(i==3 && currenty>0)
			{
				ok=true;
			}
			if(ok==true){
				unsigned int mx= currentx+hx[i];
				unsigned int my= currenty+hy[i];
				//para cada adyacente que no este en la listca cerrada
				if(gGameState.currentMap[mx][my]==TT_None && pathMap[mx][my].close==0)
				{
					int g = pathMap[currentx][currenty].g + 1;
					int h = abs(endx-mx) + abs(endy-my);
										
					//si no esta en la lista abierta
					if(pathMap[mx][my].open==0)
					{
						pathMap[mx][my].g = g;
						pathMap[mx][my].h = h;
						pathMap[mx][my].parentx = currentx;
						pathMap[mx][my].parenty = currenty;
						pathMap[mx][my].f = g + h;
						AddOpen(mx, my);
					}
					else if(g < pathMap[mx][my].g)
					{
						pathMap[mx][my].g = g;
						pathMap[mx][my].f =g + h;
						pathMap[mx][my].parentx = currentx;
						pathMap[mx][my].parenty = currenty;
					}				
				}
			}
		}
		init=1;
	}
	
	}
	
	printf("Error");
	
	PushPathNode(stack, startx, starty);
	
	return stack;
}


