    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Mass Arroyo,Javier I. Cano Alberola,Jaume Gasa Gmez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
 
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "motion.h"
#include "animation.h"
#include "actor.h"
#include "motionpath.h"

// =======================================================================
//	MoveActor
// -----------------------------------------------------------------------
//	Move the actor towards her facing direction.
// =======================================================================
void MoveActor(Actor* actor, bool playAnimation)
{
	if(actor->movement.active)
		return;
	
	actor->movement.active = true;
	actor->movement.repeat = true;
	actor->movement.direction = actor->direction;
	
	if(actor->animation != NULL)
	{
		if(playAnimation)
			PlayAnimation(actor->animation);
		else
			StopAnimation(actor->animation);
	}
}

void MoveActorDirection(Actor* actor, Direction direction, bool playAnimation)
{
	if(actor->movement.active)
		return;
	
	SetActorDirection(direction, actor);
	MoveActor(actor, playAnimation);
}

// =======================================================================
//	PauseActorMovement
// -----------------------------------------------------------------------
//	Pauses the actor movement if it's currently running.
// =======================================================================
void PauseActorMovement(Actor* actor)
{
	if(!actor->movement.active)
		return;
	
	actor->movement.active = false;
}

// =======================================================================
//	ResumeActorMovement
// -----------------------------------------------------------------------
//	Resumes the actor movement if it has been previously paused.
// =======================================================================
void ResumeActorMovement(Actor* actor)
{
	if(actor->movement.active)
		return;
		
	actor->movement.active = true;
}

// =======================================================================
//	StopActor
// -----------------------------------------------------------------------
//	Stops the actor movement.
// =======================================================================
void StopActorMovement(Actor* actor, bool stopAnimation)
{
	if(!actor->movement.active)
		return;
	
	actor->movement.active = false;
	actor->movement.repeat = false;
	
	if(actor->animation != NULL)
	{
		if(stopAnimation)
			StopAnimation(actor->animation);
		else
			PlayAnimation(actor->animation);
	}
}

// =======================================================================
//	MoveActorTiles
// -----------------------------------------------------------------------
//	Move the actor a given number of tiles.
// =======================================================================
void MoveActorTiles(Actor* actor, Direction direction, UI8 amount, bool animateOnMove, bool animateOnStop)
{
	if(direction == DIR_UP || direction == DIR_DOWN)
		MoveActorPixels(actor, direction, amount * K_TILE_HEIGHT, animateOnMove, animateOnStop);
	else
		MoveActorPixels(actor, direction, amount * K_TILE_WIDTH, animateOnMove, animateOnStop);
}

// =======================================================================
//	MoveActorPixels
// -----------------------------------------------------------------------
//	Move the actor a given number of pixels.
// =======================================================================
void MoveActorPixels(Actor* actor, Direction direction, UI8 amount, bool animateOnMove, bool animateOnStop)
{
	if(actor->movement.active)
		return;
	
	SetActorDirection(direction, actor);
	
	amount;
	direction;
	actor;
	
	//AddMotionPathPixelMovement(direction, actor);
	//actor->movement = GetNextMotionPathMovement(&actor->motionPath);
	MoveActor(actor, animateOnMove);
	animateOnStop;
	/*
	Movement* movement = &gActorMovements[actor->id];
	
	if(movement->active)
		return;
	
	SetActorDirection(direction, actor);
	
	switch(direction)
	{
		case DIR_DOWN :
			movement->x = actor->screenCoords.x;
			movement->y = actor->screenCoords.y + amount;
			break;
		case DIR_RIGHT :
			movement->x = actor->screenCoords.x + amount;
			movement->y = actor->screenCoords.y;
			break;
		case DIR_LEFT :
			movement->x = actor->screenCoords.x - amount;
			movement->y = actor->screenCoords.y;
			break;
		case DIR_UP :
			movement->x = actor->screenCoords.x;
			movement->y = actor->screenCoords.y - amount;
			break;
	}
	
	movement->active = true;
	movement->animateOnStop = animateOnStop;
	
	MoveActor(actor, animateOnMove);
	*/
}

// =======================================================================
//	UpdateActorMovement
// -----------------------------------------------------------------------
//	Updates the actor's movement if any.
// =======================================================================
void UpdateActorMovement(Actor* actor)
{
	if(!actor->movement.active || actor->movement.repeat)
		return;
	
	// If the actor has reached the destination, stop the movement and
	// grab the next movement (if any) in the motion path array
	if(actor->screenCoords.x == actor->movement.x && actor->screenCoords.y == actor->movement.y)
	{
		Movement* next = GetNextMotionPathMovement(&actor->motionPath);
		
		if(next == NULL)
		{
			StopActorMovement(actor, actor->movement.animateOnStop);
		}
		else
		{
			CreateMovementCoords(&(actor->movement), actor->screenCoords.x, actor->screenCoords.y,
				next->direction, abs(actor->movement.x - next->x) + abs(actor->movement.y - next->y));
			actor->movement.active	   	= true;
			actor->movement.repeat		= false;
			actor->movement.animateOnStop 	= next->animateOnStop;
			
			SetActorDirection(next->direction, actor);
		}
	}
	
	/*Movement* movement = &gActorMovements[actor->id];
	
	if(!movement->active)
		return;
	
	// If the actor have reached the destination, stop the movement
	if(actor->screenCoords.x == movement->x && actor->screenCoords.y == movement->y)
	{
		StopActor(actor, movement->animateOnStop);
	
		movement->x 				= 0;
		movement->y 				= 0;
		movement->active 			= false;
		movement->animateOnStop 	= false;
	}*/
}
