#include "sprite.h"

// =======================================================================
//	DrawSpriteAddr
// -----------------------------------------------------------------------
//	Draws a sprite starting from the given address with known width and
//	height.
// =======================================================================
void DrawSpriteAddr(UI8* addr, UI8 width, UI8 height, const I8* sprite)
{
	addr;
	width;
	height;
	sprite;

	__asm
		LD L, 4(IX) 
		LD H, 5(IX) 
		LD C, 6(IX) 
		LD B, 7(IX)            
		LD E, 8(IX) 
		LD D, 9(IX) 

		_loop_alto2:
			PUSH BC
			LD B,C
			PUSH HL
		_loop_ancho2:
			LD A,(DE)
			CP #0
			JP Z, _notpaint
			LD (HL),A
		_notpaint:
			INC DE
			INC HL
			DJNZ _loop_ancho2
			POP HL
			LD A,H
			ADD #0x08
			LD H,A
			SUB #0xC0
			JP NC, _sig_linea2
			LD BC, #0xC050
			ADD HL,BC
		_sig_linea2:
			POP BC
			DJNZ _loop_alto2
    __endasm;
}

// =======================================================================
//	DrawSprite
// -----------------------------------------------------------------------
//	Draws a sprite starting from the top left (x, y) position with known
//	width and height.
// =======================================================================
void DrawSprite(UI8 x, UI8 y, UI8 width, UI8 height, const I8* sprite)
{
	DrawSpriteAddr((UI8*) 0xC000 + (y / 0x8) * 0x50 + (y % 0x8) * 0x800 + (x / 0x2), width, height, sprite);
}
