    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Massó Arroyo,Javier I. Cano Alberola,Jaume Gasa Gómez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include <stdlib.h>
#include <stdio.h>

#include "game.h"
#include "globals.h"
#include "graphics.h"
#include "map.h"
#include "actor.h"
#include "input.h"
#include "time.h"
#include "sprites.h"

void Init()
{ 
	gActorList = CreateNode(NULL);
        
	SetMode(0);
	SetBorderColor(0);
	SetPalette(GamePalette, NUM_COLORS);
        
        PaintRectangle((unsigned char*)0xC000, TILE_HEIGHT, K_SCR_WIDTH, 0xFF);
        
        gGameState.time.mins = 3;
        gGameState.time.secs = 12;
        gGameState.time.lastTime = GetTime();
        gGameState.debt = 60000;
        gGameState.suicide = 30000;

	LoadMap();
        DrawMap();
        
        updateDebt();
        updateSuicide();
        updateTime();
}

void updateDebt()
{
    PaintRectangle((unsigned char*)DEBTHOLDER_POS, SPRITE_NUMBER_HEIGHT, SPRITE_NUMBER_WIDTH*7*2, 0xFF);
    PrintHolder(gGameState.debt, (unsigned char *)(DEBTHOLDER_POS + SPRITE_NUMBER_WIDTH*6));
}

void updateSuicide()
{
    PaintRectangle((unsigned char*)SUICIDEHOLDER_POS, SPRITE_NUMBER_HEIGHT, SPRITE_NUMBER_WIDTH*7*2, 0xFF);
    PrintHolder(gGameState.suicide, (unsigned char *)(SUICIDEHOLDER_POS + SPRITE_NUMBER_WIDTH*6));
}

void updateTime()
{ 
    
    if(GetTime() - gGameState.time.lastTime >= 300)
    {
        PaintRectangle((unsigned char*)TIMEHOLDER_POS, SPRITE_NUMBER_HEIGHT, SPRITE_NUMBER_WIDTH*5*2, 0xFF);
        
        __asm
                ld h, #1
                ld l, #1
                call #0xBB75
        __endasm;

        if (gGameState.time.secs == 0)
        {
            gGameState.time.secs = 60;
            gGameState.time.mins--;
        }
        gGameState.time.secs--;
        

        PrintHolder(gGameState.time.mins, (unsigned char *)(TIMEHOLDER_POS + SPRITE_NUMBER_WIDTH*1));

        if (gGameState.time.secs < 10)
            PaintSprite((unsigned char *)(TIMEHOLDER_POS + SPRITE_NUMBER_WIDTH*3-1), SPRITE_NUMBER_WIDTH, SPRITE_NUMBER_HEIGHT, NumbersSprite[0]);
        if (gGameState.time.secs == 0)
            PaintSprite((unsigned char *)(TIMEHOLDER_POS + SPRITE_NUMBER_WIDTH*4), SPRITE_NUMBER_WIDTH, SPRITE_NUMBER_HEIGHT, NumbersSprite[0]);        

        PrintHolder(gGameState.time.secs, (unsigned char *)(TIMEHOLDER_POS + SPRITE_NUMBER_WIDTH*4));

        gGameState.time.lastTime = GetTime();
    }
      
}
