    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Massó Arroyo,Javier I. Cano Alberola,Jaume Gasa Gómez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include "globals.h"

ActorList *gActorList;
GameState gGameState;
PathStack gActorPaths[K_MAX_PATH_STACKS];

// ========================================================================
// 								MAPS
// ========================================================================

const gTileType map1[] =
{
	
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 2, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 2, 0, 0, 0, 0, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 2, 1, 2, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
                
};

const ActorSubType actors_map1[] = 
{
         
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 1, 0, 0, 2, 0,
	0, 0, 0, 0, 4, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0,
	0, 0, 0, 5, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 5, 0, 0, 0, 5, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 3, 6, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 2, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

// ========================================================================
// 								SPRITES
// ========================================================================

const unsigned char GamePalette[NUM_COLORS] = { 8, 12, 3, 26, 23, 10, 6, 24, 15, 0, 25, 13, 18, 0, 0, 0 };

const char BlockSprite[] =
{
			   0x8C, 0x0C, 0x0C, 0x4C, 0x48, 0xC0, 0xC0, 0x84
        ,      0x48, 0xC0, 0xC0, 0x84, 0x48, 0xC0, 0xC0, 0x84
        ,      0x48, 0xC0, 0xC0, 0x84, 0x48, 0xC0, 0xC0, 0x84
        ,      0x48, 0xC0, 0xC0, 0x84, 0x48, 0xC0, 0xC0, 0x84
        ,      0x48, 0xC0, 0xC0, 0x84, 0x8C, 0x0C, 0x0C, 0x4C
};

const char GroundSprite[] =
{
			   0xB0, 0x30, 0x30, 0x70, 0x70, 0x30, 0x30, 0xB0
        ,      0x30, 0xB0, 0x70, 0x30, 0x30, 0xB0, 0x70, 0x30
        ,      0x30, 0x70, 0xB0, 0x30, 0x30, 0x70, 0xB0, 0x30
        ,      0x30, 0xB0, 0x70, 0x30, 0x30, 0xB0, 0x70, 0x30
        ,      0x70, 0x30, 0x30, 0xB0, 0xB0, 0x30, 0x30, 0x70
};

const char LavaSprite[] =
{
			   0x3C, 0x3C, 0xBC, 0x3C, 0xBC, 0x3C, 0x56, 0xBC
        ,      0x56, 0xBC, 0x29, 0x56, 0x29, 0x16, 0x3C, 0x29
        ,      0x3C, 0x3C, 0xFC, 0x3C, 0x3C, 0x3C, 0x03, 0xBC
        ,      0x7C, 0x3C, 0x3C, 0x16, 0x29, 0xFC, 0x3C, 0x3C
        ,      0x3C, 0x03, 0x7C, 0x3C, 0x3C, 0x3C, 0x29, 0xFC
};

const char CharacterSprite[] =
{
			   0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0xC3, 0x00
        ,      0x41, 0xC3, 0xC3, 0x82, 0xC3, 0xC3, 0xC3, 0xC9
        ,      0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3
        ,      0xC3, 0xC3, 0xC3, 0xC9, 0x41, 0xC3, 0xC3, 0x82
        ,      0x00, 0xC3, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00
};


const char Money1Sprite[] =
{
               0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        ,      0x00, 0xC3, 0xC3, 0x00, 0x41, 0xDC, 0xFC, 0x82
        ,      0xC6, 0xDC, 0xFC, 0xE9, 0xD6, 0xFC, 0xFC, 0xE9
        ,      0x41, 0xFC, 0xFC, 0x82, 0x00, 0xC3, 0xC3, 0x00
        ,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

const char Money2Sprite[] =
{
               0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        ,      0x00, 0xC3, 0xC3, 0x00, 0x41, 0x89, 0x03, 0x82
        ,      0xC6, 0x89, 0x03, 0x43, 0x83, 0x03, 0x03, 0x43
        ,      0x41, 0x03, 0x03, 0x82, 0x00, 0xC3, 0xC3, 0x00
        ,      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
const char Money3Sprite[] =
{
               0x00, 0x00, 0x00, 0x00, 0x41, 0xC3, 0xC3, 0x82
        ,      0x87, 0x5E, 0xFC, 0xE9, 0xC3, 0xC3, 0xC3, 0xC3
        ,      0x87, 0x4F, 0xCF, 0xCB, 0x87, 0xCF, 0xCF, 0xCB
        ,      0x87, 0xCF, 0xCF, 0xCB, 0x87, 0xCF, 0xCF, 0xCB
        ,      0xC7, 0xCF, 0xCF, 0xCB, 0x41, 0xC3, 0xC3, 0x82
};

const char Enemy1Sprite[] =
{
               0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0xC3, 0x00
        ,      0x41, 0x33, 0x33, 0x82, 0x93, 0x69, 0x36, 0xC3
        ,      0x93, 0x33, 0x93, 0x63, 0x93, 0x33, 0x33, 0x63
        ,      0x93, 0xC3, 0xC3, 0x63, 0x41, 0x33, 0x33, 0x82
        ,      0x00, 0xC3, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00
};

extern const char NumbersSprite[10][SPRITE_NUMBER_WIDTH * SPRITE_NUMBER_HEIGHT] =
{
    {
        0x0A, 0x0A, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x0A, 0x00, 0x0A,
        0x0A, 0x00, 0x0A,
        0x0A, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
    },
    {
       0x00, 0x00, 0x0A,
       0x00, 0x00, 0x0A,
       0x00, 0x00, 0x0A,
       0x00, 0x00, 0x0A,
       0x00, 0x00, 0x0A,
       0x00, 0x00, 0x0A,
    },
    {
       0x0A, 0x0A, 0x0A,
       0x0A, 0x0A, 0x0A,
       0x00, 0x00, 0x0A,
       0x0A, 0x0A, 0x0A,
       0x0A, 0x00, 0x00,
       0x0A, 0x0A, 0x0A,
    },
    {
        0x0A, 0x0A, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x00, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x00, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
    },
    {
        0x0A, 0x00, 0x0A,
        0x0A, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x00, 0x00, 0x0A,
        0x00, 0x00, 0x0A,
    },
    {
        0x0A, 0x0A, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x0A, 0x00, 0x00,
        0x0A, 0x0A, 0x0A,
        0x00, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
    },
    {
        0x0A, 0x0A, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x0A, 0x00, 0x00,
        0x0A, 0x0A, 0x0A,
        0x0A, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
    },
    {
        0x0A, 0x0A, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x00, 0x00, 0x0A,
        0x00, 0x00, 0x0A,
        0x00, 0x00, 0x0A,
        0x00, 0x00, 0x0A,
    },
    {
        0x0A, 0x0A, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x0A, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x0A, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
    },
    {
        0x0A, 0x0A, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x0A, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
        0x00, 0x00, 0x0A,
        0x0A, 0x0A, 0x0A,
    }
};
