    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Massó Arroyo,Javier I. Cano Alberola,Jaume Gasa Gómez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include "graphics.h"
#include "sprites.h"
#include "globals.h"

void SetMode(unsigned char mode)
{
	mode;
	
	__asm
		ld a, 4 (ix)
		call 0xBC0E
	__endasm;
}

unsigned char* GetLineAddress(unsigned char line)
{
	return (unsigned char*) 0xC000 + (line / 0x8) * 0x50 + (line % 0x8) * 0x800;
}

unsigned char* GetLineAddressFrom(unsigned char* pIni, unsigned char line)
{
	return (unsigned char*) pIni + (line / 0x8) * 0x50 + (line % 0x8) * 0x800;
}

void SetBorderColor(unsigned char color)
{
	color;
	
	__asm
		ld b, 4 (ix)
		ld c, b
		call #0xBC38
	__endasm;
}

void PaintPixelFast(unsigned char *address, unsigned char x, unsigned char color)
{
	unsigned char pixPosition = x / K_SCR_PPB;
	unsigned char byte = address[pixPosition];

	if((x % K_SCR_PPB) == 0)
	{
		//byte &= 85;
	
		if(color & 1)
			byte |= 0x80;
		if(color & 2)
			byte |= 0x08;
		if(color & 4)
			byte |= 0x20;
		if(color & 8)
			byte |= 0x02;
	}
	else
	{
		//byte &= 170;
		
		if(color & 1)
			byte |= 0x40;
		if(color & 2)
			byte |= 0x04;
		if(color & 4)
			byte |= 0x10;
		if(color & 8)
			byte |= 0x01;
	}
	
	address[pixPosition] = byte;
}

void PaintPixel(unsigned char x, unsigned char y, unsigned char color)
{
	PaintPixelFast(GetLineAddress(y), x, color);
}

void SetColor(unsigned char colorIndex, unsigned char paletteIndex)
{
	colorIndex;
	paletteIndex;
	
	__asm
		ld a, 4 (ix)
		ld b, 5 (ix)
		ld c, b
		call #0xBC32
	__endasm;
}

void SetPalette(unsigned char *palette, unsigned char numColors)
{
	unsigned char colorCounter = 0;
	
	for(colorCounter = 0; colorCounter < numColors; ++colorCounter)
	{
		SetColor(colorCounter, palette[colorCounter]);
	}
}

void PaintScreen(unsigned char color)
{
    unsigned char *pScreen = (unsigned char *)0xC000;
    unsigned int nByte = 0;
    unsigned int nLine = 0;

    for(nLine = 0; nLine < 200; nLine++)
    {
        pScreen = GetLineAddress(nLine);

        for(nByte = 0; nByte < 80; nByte++)
          pScreen[nByte] = (unsigned char)color;
    }
}

void PaintRectangle(unsigned char* pIni, unsigned int height, unsigned int width, unsigned char color)
{
    unsigned int nByte = 0;
    unsigned int nLine = 0;
    unsigned char *pScreen = (unsigned char*)0xC000;

    for (nLine = 0; nLine < height; nLine++)
    {
        pScreen = GetLineAddressFrom(pIni, nLine);
        for (nByte = 0; nByte < width; nByte++)
            PaintPixelFast(pScreen, nByte, (unsigned char)color);

    }   
}

void PrintHolder(unsigned int value, unsigned char* pAddress)
{   
    while (value > 0)
    {
        int x = value % 10;
        PaintSprite(pAddress, SPRITE_NUMBER_WIDTH, SPRITE_NUMBER_HEIGHT, NumbersSprite[x]);
        pAddress = pAddress - 0x4;
        value = value/10;
    }
}
