    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Mass Arroyo,Javier I. Cano Alberola,Jaume Gasa Gmez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "sprites.h"
#include "map.h"
#include "actor.h"

void LoadMap()
{
    gTileType* map;
    ActorSubType* map1actors;
    
    map = map1;
    map1actors = actors_map1;
    
    LoadMap_Background(map, gGameState.currentMap);
    LoadMap_Actors(map1actors, gGameState.currentMapActors);
}

void LoadMap_Background(gTileType *map, Map mapPtr)
{
	unsigned int x = 0;
	unsigned int y = 1;
	unsigned int counter = 0;
	
	// Copy part A of the map
	for(y = 1; y < MAP_HEIGHT; ++y)
	{
		for(x = 0; x < MAP_WIDTH; ++x)
		{
			mapPtr[x][y] = map[counter];
			
			counter++;
		}
	}
}

void LoadMap_Actors(ActorSubType *map, Map_Actors mapPtr)
{
	unsigned int x = 0;
	unsigned int y = 1; //El primer actor ya est creado en Game.c Init(), es el jugador
	unsigned int counter = 0;
	
	// Copy part A of the map
	for(y = 1; y < MAP_HEIGHT; ++y)
	{
		for(x = 0; x < MAP_WIDTH; ++x)
		{
                    switch(map[counter])
                    {
                        case ST_Beggar1:
                            mapPtr[x][y] = CreateActor(x,y,Enemy1Sprite,AT_ENEMY,ST_Beggar1);
                            break;
                        case ST_Beggar2:
                            mapPtr[x][y] = CreateActor(x,y,Enemy1Sprite,AT_ENEMY,ST_Beggar1);
                            break;
                        case ST_Beggar3:
                            mapPtr[x][y] = CreateActor(x,y,Enemy1Sprite,AT_ENEMY,ST_Beggar1);
                            break;
                        case ST_Money1:
                            mapPtr[x][y] = CreateActor(x,y,Money1Sprite,AT_ITEM,ST_Money1);
                            break;
                        case ST_Money2:
                            mapPtr[x][y] = CreateActor(x,y,Money2Sprite,AT_ITEM,ST_Money2);
                            break;
                        case ST_Money3:
                            mapPtr[x][y] = CreateActor(x,y,Money3Sprite,AT_ITEM,ST_Money3);
                            break;
                    }
			 		
                    counter++;
		}
	}
}


void DrawMap()
{
    DrawMap_Background(gGameState.currentMap);
}

void DrawMap_Background(Map mapPtr)
{
    unsigned char x = 0;
    unsigned char y = 0;

    for(x = 0; x < MAP_WIDTH; ++x)
    {
            for(y = 0; y < MAP_HEIGHT; ++y)
            {
                    switch(mapPtr[x][y])
                    {
                            case TT_None : DrawTile(x, y, GroundSprite); break;
                            case TT_Block : DrawTile(x, y, BlockSprite); break;
                            case TT_Lava : DrawTile(x, y, LavaSprite); break;
                            default : break;
                    }
            }
    }
}

unsigned char* GetTileAddress(unsigned char x, unsigned char y)
{
	return (unsigned char *) 0xC000 + ((y * TILE_HEIGHT) / 8u) * 80u + ((y * TILE_HEIGHT) % 8) * 2048u + ((x * TILE_WIDTH) / 2u);
}

void DrawTile(unsigned char x, unsigned char y, const unsigned char *sprite)
{
	unsigned char *addr = GetTileAddress(x, y);
	
	PaintSprite(addr, TILE_WIDTH / 2, TILE_HEIGHT, sprite);
}

void DrawTileType(unsigned char x, unsigned char y, gTileType tileType)
{
	switch(tileType)
	{
		case TT_None : DrawTile(x, y, GroundSprite); break;
		case TT_Block : DrawTile(x, y, BlockSprite); break;
		case TT_Lava : DrawTile(x, y, LavaSprite); break;
		default : break;
	}
}

void Tile2Buff(unsigned char x, unsigned char y, unsigned char *buffer)
{
	unsigned char yTile = 0;
	unsigned char *addr = GetTileAddress(x, y);
	
	for(yTile = 0; yTile < TILE_HEIGHT; ++yTile)
	{	
		memcpy(buffer + yTile * TILE_WIDTH / 2, addr, TILE_WIDTH / 2);

		if(addr >= (unsigned char *) 0xF800)
			addr = addr - 0x3800 + 0x50;
		else
			addr = addr + 0x800;
	}
}

unsigned char Color2PixByte(unsigned int colorNumber)
{
	switch(colorNumber)
	{
		case 0 : return 0x0;
		case 1 : return 0xC0;
		case 2 : return 0x0C;
		case 3 : return 0xCC;
		case 4 : return 0x30;
		case 5 : return 0xF0;
		case 6 : return 0x3C;
		case 7 : return 0xFC;
		case 8 : return 0x03;
		case 9 : return 0xC3;
		case 10 : return 0x0F;
		case 11 : return 0xCF;
		case 12 : return 0x33;
		case 13 : return 0xF3;
		case 14 : return 0x3F;
		case 15 : return 0xFF;
		default : break;
	}
	
	return 0x0;
}

