    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Massó Arroyo,Javier I. Cano Alberola,Jaume Gasa Gómez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "path.h"
#include "input.h"

void CreatePathStack(PathStack *stack, const Actor *actorPtr, unsigned char maxSize)
{
	PathNode *elements;

	if(stack != NULL && stack->maxSize != maxSize)
	{	
		elements = (PathNode*) malloc(sizeof(PathNode) * maxSize);
	}
	else
	{
		elements = stack->contents;
	}
	
	if(elements == NULL)
	{
		printf("STACK. Insufficient memory");
	}
	
	stack->top 		= -1;
	stack->maxSize 	= maxSize;
	stack->actor 	= actorPtr;
	stack->contents 	= elements;
}

void DeletePathStack(PathStack *stack)
{
	if(stack == NULL)
		return;
	
	stack->top = -1;
	stack->maxSize = 0;
	stack->actor = NULL;
	free(stack->contents);
}

PathNode* PopPathNode(PathStack *stack)
{
	if(IsPathStackEmpty(stack))
		return NULL;
	
	return &stack->contents[stack->top--];
}

void PushPathNode(PathStack *stack, unsigned char x, unsigned char y)
{
	if(IsPathStackFull(stack))
		return;
	
	stack->contents[++stack->top].x = x;
	stack->contents[stack->top].y = y;
}

bool IsPathStackFull(PathStack *stack)
{
	return stack->top >= stack->maxSize - 1;
}

bool IsPathStackEmpty(PathStack *stack)
{
	return stack->top < 0;
}