    /*Project of game for amstad cpc 464.
    Copyright (C) 2013  Crappy Games(Antiono Lopez Quinto,David Massó Arroyo,Javier I. Cano Alberola,Jaume Gasa Gómez) 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
	
#include <stdio.h>
#include <math.h>

#include "globals.h"
#include "time.h"

unsigned int fps = 0;
unsigned int fpsStart = 0;
unsigned int frameStart = 0;
unsigned char hTime, lTime;

unsigned int GetTime()
{	
	__asm
		call #0xBD0D
		push hl
		pop de
		ld hl, #_hTime
		ld (hl), d
		ld hl, #_lTime
		ld (hl), e
	__endasm;
	
	return (hTime << 8) + lTime;
}

void FrameStart()
{
	fpsStart = GetTime();
	frameStart = GetTime();
}

void FrameEnd()
{
	if(GetTime() - frameStart < K_TIME_UNITS_PER_FRAME)
	{
		while(GetTime() - frameStart < K_TIME_UNITS_PER_FRAME) {}
	}
	else		// Frame rate governing
	{
		frameStart = GetTime();
		
		while(GetTime() - frameStart < K_TIME_UNITS_PER_FRAME) {}
	}
	
	FpsUpdate();
	frameStart = GetTime();
}

void FpsUpdate()
{
	++fps;
	
	if(GetTime() - fpsStart >= 300)
	{
		__asm
			ld h, #1
			ld l, #1
			call #0xBB75
		__endasm;
		
		//printf("%u FPS", fps);
		
		fpsStart = GetTime();
		fps = 0;
	}
}